
(* Question 1*)

let tripletToSommet n (x,y,z) = 
(n+1)*x + y + (n+1)*(n+1)*z;;


let sommetToTriplet n i =
 let y = i mod (n + 1) in
 let u = i / (n + 1) in
 let x = u mod (n + 1) in
 let z = u / (n + 1) in
 (x, y, z);;


(* Question 2*)
let transports n p x y =
 let res = ref [] in
 for beta = 0 to y do
  for alpha = 0 to x do
   if ((alpha + beta) >= 1)
    && ((alpha + beta) <= p)
    && (alpha = 0 || alpha >= beta)
    && ((x = alpha) || (x - alpha >= y - beta))
    && ((n - x + alpha = 0) || (n - x + alpha >= n - y + beta))
   then res := (alpha, beta) :: !res
  done;
 done;
 !res;;


(* Question 3*)
let graphe n p =
 let taille = 2 * (n + 1) * (n + 1) in
 let t = Array.make taille [] in
 for i = 0 to taille - 1 do
  let (x, y, z) = sommetToTriplet n i in
  if z = 0 then 
  let rec parcours1 l = match l with 
  | [] -> ()
  | (xt,yt) :: q -> t.(i) <- tripletToSommet n (x - xt, y - yt, 1) :: t.(i) ; parcours1 q
  in parcours1 (transports n p x y)
  else 
  let rec parcours2 l = match l with 
  | [] -> ()
  | (xt,yt) :: q -> t.(i) <- tripletToSommet n (x + xt, y + yt, 0) :: t.(i) ; parcours2 q
  in parcours2 (transports n p (n-x) (n-y))
 done;
 t;;

graphe 3 2;;

(* Question 4.a)*)
(* On programme un parcours en profondeur pour determiner si (0,0,1) est dans la composante connexe du graphe 
contenant (n,n,0)*)

let possible n p =
 let g = graphe n p in
 let debut = tripletToSommet n (n, n, 0) and fin = tripletToSommet n (0, 0, 1) in
 let visit = Array.make (Array.length g) false in
 let rec parcours i =
  if not visit.(i) then
   (visit.(i) <- true;
    let rec aux l =
     match l with
      | [] -> ()
      | t :: q -> parcours t; aux q
    in
    aux g.(i))
 in parcours debut;
 visit.(fin);;

(* Question 4.b)*)
(* On commence par une fonction solution1 qui renvoie le tableau prec ainsi que le boolen pour savoir
si on peut trouver une solution *)

let solution1 n p =
 let g = graphe n p in
 let debut = tripletToSommet n (n, n, 0) and fin = tripletToSommet n (0, 0, 1) in
 let visit = Array.make (Array.length g) false in
 let prec = Array.make (Array.length g) (- 1) in
 let rec parcours i provenance =
  if not visit.(i) then
   (visit.(i) <- true;
    prec.(i) <- provenance;
    let rec aux l =
     match l with
      | [] -> ()
      | t :: q -> parcours t i; aux q
    in
    aux g.(i))
 in parcours debut debut;
 visit.(fin), prec;;

solution1 3 2;;

(* La fonction solutionSommets renvoie la liste des sommets du chemin *)

let solutionSommets n p =
 let debut = tripletToSommet n (n, n, 0) and fin = tripletToSommet n (0, 0, 1) in
 let bool, prec = solution1 n p in
 if bool then
  let rec reconstruit k acc =
   if k = debut then (debut :: acc) else reconstruit prec.(k) (k :: acc)
  in reconstruit fin []
 else failwith "pas de solutions";;

(* Il reste  calculer les dplacememnts*)

let rec difference n i j =
 if i > j then let u = abs (i - (n + 1) * (n + 1) - j) in
  (u / (n + 1), u mod (n + 1))
 else difference n j i;;





let solution n p =
 let l = solutionSommets n p in
 let rec differenceListe l = match l with
   | [] -> []
   | [a] -> []
   | t1 :: t2 :: q -> (difference n t1 t2) :: (differenceListe (t2 :: q))
 in
 differenceListe l;;

solution 3 2;;



(* On a ralis un parcours en profondeur ; nous ne sommes pas surs que la solution renvoye est 
"la plus courte". On pourrait reprendre l'exercice  l'aide d'un parcours en largeur *)


(* A-star *)

(* Pour aller plus vite, on implemente F dans une liste - c'est peu efficace, il faudrait prendre 
une file de priorit classe selon les valeurs de f + h *)

let h n x =
 let (xi, yi, zi) = sommetToTriplet n x in
 (xi + yi)/2;;


let pluspetit l = match l with
  | [] -> failwith "la liste est vide"
  | (x0, p0, g0, h0) :: q -> let rec pluspetit l (i, pi, gi, hi) reste = match l with
       | [] -> ((i, pi, gi, hi), reste)
       | (t, pt, gt, ht) :: q -> if (gt + ht) < (gi + hi) then pluspetit q (t, pt, gt, ht) ((i, pi, gi, hi) :: reste)
          else pluspetit q (i, pi, gi, hi) ((t, pt, gt, ht) :: reste)
     in pluspetit q (x0, p0, g0, h0) [];;




let astar n p h =
 let g = graphe n p in
 let i = tripletToSommet n (n, n, 0) and t = tripletToSommet n (0, 0, 1) in
 let visit = Array.make (Array.length g) false in
 let prec = Array.make (Array.length g) (- 1) in
 let f = ref [(i, - 1, 0, h n i)] in
 while (!f <> []) && not (visit.(t)) do
  let (x, p, gx, hx), q = pluspetit !f in
  f := q;
  visit.(x) <- true;
  prec.(x) <- p;
  let rec aux l = match l with
    | [] -> ()
    | y :: q -> if not (visit.(y)) then f := (y, x, gx + 1, h n y) :: !f; aux q
  in aux g.(x)
 done;
 prec;;

astar 3 2 h;;
      
      (* On peut alors reconstruire le chemin comme prcdemment*)
      
